//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string VchParams = "0,10,0,T,10,4.0,1;1,12,0,T,12,3.5,1;4,14,0,T,14,3.0,1;5,16,0,F,16,2.5,1;6,18,0,F,18,2.0,1";
extern string Dummy     = "";
extern bool   InheritState = false;

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
double smlengths[];
double smphases[];
double smdoubles[];
double atrlengths[];
double vchprices[];
double vchks[];
double vchrisks[];
int    size;

bool   calculateVolty;
string indicatorFileName;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
      VchParams = StringTrimLeft(StringTrimRight(VchParams));
      if (StringSubstr(VchParams,StringLen(VchParams),1) != ";")
                       VchParams = StringConcatenate(VchParams,";");

         //
         //
         //
         //
         //                                   

         int n,m,s = 0;
         int i = StringFind(VchParams,";",s);
         while (i > 0)
         {
            string current = StringSubstr(VchParams,s,i-s);
            if (current!=";")
            {
               size = ArraySize(vchprices)+1;
                      ArrayResize(vchprices,size);
                      ArrayResize(smlengths,size);
                      ArrayResize(smphases ,size);
                      ArrayResize(smdoubles,size);
                      ArrayResize(atrlengths,size);
                      ArrayResize(vchks     ,size);
                      ArrayResize(vchrisks  ,size);
                        n = StringFind(current,",",0); vchprices[size-1]  = StrToDouble(StringSubstr(current,0,n));   m = n+1; 
                        n = StringFind(current,",",m); smlengths[size-1]  = StrToDouble(StringSubstr(current,m,n-m)); m = n+1;
                        n = StringFind(current,",",m); smphases[size-1]   = StrToDouble(StringSubstr(current,m,n-m)); m = n+1;
                        n = StringFind(current,",",m); smdoubles[size-1]  = booToDouble(StringSubstr(current,m,n-m)); m = n+1;
                        n = StringFind(current,",",m); atrlengths[size-1] = StrToDouble(StringSubstr(current,m,n-m)); m = n+1;
                        n = StringFind(current,",",m); vchks[size-1]      = StrToDouble(StringSubstr(current,m,n-m)); m = n+1;
                                                       vchrisks[size-1]   = StrToDouble(StringSubstr(current,m,StringLen(current)-m));
            }
            s = i + 1;
            i = StringFind(VchParams,";",s);
         }
         calculateVolty    = (Dummy=="calculateVolty");
         indicatorFileName = WindowExpertName();
         
         //
         //
         //
         //
         //
         
   IndicatorShortName("Volty channel stop on jurik summed "+size);
   return(0);
}
double booToDouble(string param)
{
   if (param=="F" || param=="f") return(0);
   if (param=="T" || param=="t") return(1);
                                 return(0);
}
string boolToString(double param)
{
   if (param==0) return("F");
   if (param==1) return("T");
                 return("F");
}

//
//
//
//
//

int deinit()
{
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         if (calculateVolty)
         {
            for(int i=limit; i>=0; i--)
            {
               if(vchprices[0]==2 || vchprices[0]==3)
               {
                  double bprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),smlengths[0],smphases[0],(bool)smdoubles[0],i, 0);
                  double sprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i),smlengths[0],smphases[0],(bool)smdoubles[0],i,20);
               }
               else
               {
                         bprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,vchprices[0],i),smlengths[0],smphases[0],(bool)smdoubles[0],i, 0);
                         sprice = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,vchprices[0],i),smlengths[0],smphases[0],(bool)smdoubles[0],i,20);
               }
               buffer0[i] = iVolty(bprice,sprice,vchks[0],atrlengths[0],i);
            }
            return(0);               
         }         
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      int sum=0;
      for (int k=0; k<size; k++)
      {
         string params = DoubleToString(vchprices[k],0 )+","+
                         DoubleToString(smlengths[k],0 )+","+
                         DoubleToString(smphases[k]    )+","+
                         boolToString(smdoubles[k]     )+","+
                         DoubleToString(atrlengths[k],0)+","+
                         DoubleToString(vchks[k]       )+","+
                         DoubleToString(vchrisks[k],0  )+";";
         sum += iCustom(NULL,0,indicatorFileName,params,"calculateVolty",0,i);
      }
      if (!InheritState)
      {
         buffer0[i] = EMPTY_VALUE;
         buffer1[i] = EMPTY_VALUE;
         buffer2[i] = EMPTY_VALUE;
            if (sum== size) { buffer0[i] = 1; continue; }
            if (sum==-size) { buffer1[i] = 1; continue; }
                              buffer2[i] = 1;
      }
      else
      {
         buffer0[i] = buffer0[i+1];
         buffer1[i] = buffer1[i+1];
            if (sum== size) { buffer0[i] = 1; buffer1[i] = EMPTY_VALUE; continue; }
            if (sum==-size) { buffer1[i] = 1; buffer0[i] = EMPTY_VALUE; continue; }
      }                              
   }     
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double workVolty[][3];
#define _smin  0
#define _smax  1
#define _trend 2

double iVolty(double priceb, double prices, double kv, int atrLength,int i)
{
   if (ArrayRange(workVolty,0)!=Bars) ArrayResize(workVolty,Bars); int r = Bars-i-1;
   
    workVolty[r][_smin]  = prices - kv * iATR(NULL,0,atrLength,i); 
    workVolty[r][_smax]  = priceb + kv * iATR(NULL,0,atrLength,i);
      if (r==0) { workVolty[r][_trend] = 0; return(0); }
   
      //
      //
      //
      //
      //
      
      workVolty[r][_trend] = workVolty[r-1][_trend];
	      if (priceb > workVolty[r-1][_smax]) workVolty[r][_trend] =  1;
         if (prices < workVolty[r-1][_smin]) workVolty[r][_trend] = -1;
	      if (workVolty[r][_trend] > 0 && workVolty[r][_smin] < workVolty[r-1][_smin]) workVolty[r][_smin] = workVolty[r-1][_smin];
	      if (workVolty[r][_trend] < 0 && workVolty[r][_smax] > workVolty[r-1][_smax]) workVolty[r][_smax] = workVolty[r-1][_smax];
   return(workVolty[r][_trend]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double tKv  = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - tKv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - tKv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}